// Sample.h : Declaration of the CSample

#ifndef __SAMPLE_H_
#define __SAMPLE_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CSample
class ATL_NO_VTABLE CSample : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSample, &CLSID_Sample>,
	public IObjectControl,
	public IDispatchImpl<ISample, &IID_ISample, &LIBID_DBTIERLib>
{
public:
	CSample()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

DECLARE_NOT_AGGREGATABLE(CSample)

BEGIN_COM_MAP(CSample)
	COM_INTERFACE_ENTRY(ISample)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// ISample
public:
	STDMETHOD(SampleCall)(/*[in]*/BSTR bstrCourseName, /*[out,retval]*/long *lCourseID);
};

#endif //__SAMPLE_H_
